#import <QuartzCore/QuartzCore.h> 

@protocol BRAppliance <NSObject>
- (id)applianceCategories;
- (id)identifierForContentAlias:(id)fp8;
- (BOOL)handleObjectSelection:(id)fp8 userInfo:(id)fp12;
- (id)topShelfController;
@end
@interface BRBaseAppliance : NSObject <BRAppliance>
{
	    NSArray *_categories;
}

- (id)applianceCategories;
- (id)identifierForContentAlias:(id)fp8;
- (BOOL)handleObjectSelection:(id)fp8 userInfo:(id)fp12;
- (id)alertControllerForNoContent;
- (int)noContentBRError;
- (id)alertControllerForNoRemoteContent;
- (int)noRemoteContentBRError;
- (BOOL)previewError;
- (id)previewErrorText;
- (id)previewErrorSubtext;
- (id)previewErrorIconImage;
- (id)topShelfController;
- (id)_applianceCategories;
- (BOOL)_isCategoryWithIdentifier:(id)fp8 memberOfMusicStoreCollection:(id)fp12;
- (BOOL)_anySharesAvailable;
- (BOOL)_anyStoreCategoryExistsInMusicStoreCollection:(id)fp8;

@end

@interface DHAppliance: BRBaseAppliance
@end

@implementation DHAppliance

+ (void)load
{
	//NSLog(@"BUST A LOAD");
	//CGRect screenRect = [[UIScreen mainScreen] bounds];
	Class brwin = NSClassFromString( @"BRWindow" );
	id theLayer = [[brwin rootLayer] superclass];
	NSLog(@"theLayer = %@", theLayer);
	//float radians =  90.0 / 180.0 * M_PI;
	//Class cal = NSClassFromString( @"CALayer" );
	
	/*
	 
	 try to rotate to landscape for iPhone/iPod test harness, this code will NOT be necessary for proper frappliances 
	 once a jailbreak is released.
	 
	 */
	CGAffineTransform x =  CGAffineTransformMakeRotation(0.5*3.14159);
	CGAffineTransform x2 = CGAffineTransformScale(x, 0.8, 1);
	//CGAffineTransform x3 = CGAffineTransformConcat(x, x2);
	//NSLog(@"cgrect: %@", NSStringFromCGRect(screenRect));
	CGRect rectFrame = CGRectMake(0, 0, 960, 1280);
	[[brwin rootLayer] setFrame:rectFrame];
	[[brwin rootLayer] setAffineTransform:x2];


	//[theLayer setTransform: CATransform3DMakeRotation(radians, 0.0, 0.0, 1.0)];
}

+ (void)initialize {
	NSLog(@"[DHAppliance initialize]");
}

- (id)applianceCategories {
	Class brac = NSClassFromString( @"BRApplianceCategory" );
	id filesCat = [brac categoryWithName: @"OHAI" identifier: @"ohai" preferredOrder: 0];
	NSArray *applianceArray = [NSArray arrayWithObject:filesCat];
	return applianceArray;
}

- (id)identifierForContentAlias:(id)contentAlias {
	return @"DH";
}

- (BOOL)handleObjectSelection:(id)fp8 userInfo:(id)fp12 {
	return NO;
}

- (id)topShelfController {
	return nil;
}

- (id)applianceSpecificControllerForIdentifier:(id)arg1 args:(id)arg2 { return nil; }

- (id)localizedSearchTitle { return @"DH"; }
- (id)applianceName { return @"DH (a)"; }
- (id)moduleName { return @"DH (m)"; }
- (id)applianceKey { return @"DH (m)"; }

@end

// vim:ft=objc
